import * as postcss from "postcss";
import { PluginOptions } from "../options";
import { Block } from "../Block";
import { StyleAnalysis } from "../TemplateAnalysis/StyleAnalysis";
/**
 * Compiler that, given a Block will return a transformed AST
 * interface is `BlockParser.parse`.
 */
export default class BlockCompiler {
    private opts;
    private postcss;
    constructor(postcssImpl: typeof postcss, opts?: PluginOptions);
    compile(block: Block, root: postcss.Root, analysis?: StyleAnalysis): postcss.Root;
    /**
     * Process all `@block-debug` statements, output debug statement to console or in comment as requested.
     * @param sourceFile File name of block in question.
     * @param root PostCSS Root for block.
     * @param block Block to resolve references for
     */
    processDebugStatements(sourceFile: string, root: postcss.Root, block: Block): void;
    private injectExports(root, block);
}
