import { PluginOptions, CssBlockOptionsReadonly } from "./options";
import { OutputMode } from "./OutputMode";
import { Importer, ImporterData } from "./importing";
import { BlockFactory } from "./BlockFactory";
import { Preprocessors } from "./preprocessing";
/**
 * Provides read-only access to options values. Provides default values if none
 * passed.
 */
export declare class OptionsReader implements CssBlockOptionsReadonly {
    readonly outputMode: OutputMode;
    readonly interoperableCSS: boolean;
    readonly importer: Importer;
    readonly rootDir: string;
    readonly data: ImporterData;
    readonly preprocessors: Preprocessors;
    readonly disablePreprocessChaining: boolean;
    readonly factory?: BlockFactory;
    readonly maxConcurrentCompiles: number;
    constructor(opts?: PluginOptions);
}
