import * as postcss from "postcss";
import { PluginOptions } from "./options";
export { PluginOptions } from "./options";
/**
 * CSS Blocks PostCSS plugin.
 */
export declare class Plugin {
    private opts;
    private postcss;
    /**
     * @param	postcssImpl	PostCSS instance to use
     * @param	opts	Optional plugin config options
     */
    constructor(postcssImpl: typeof postcss, opts?: PluginOptions);
    /**
     * Main processing entrypoint for PostCSS Plugin
     * @param	root	PostCSS AST
     * @param	result	Provides the result of the PostCSS transformations
     */
    process(root: postcss.Root, result: postcss.Result): Promise<void>;
}
