import { OptionsReader } from '../OptionsReader';
import { Block, BlockObject } from "../Block";
import { TemplateAnalysis, SerializedTemplateAnalysis } from "./index";
import { TemplateTypes, TemplateAnalysis as OptimizedTemplateAnalysis, TemplateIntegrationOptions } from "@opticss/template-api";
import { StyleAnalysis } from "./StyleAnalysis";
export declare class SerializedMetaTemplateAnalysis {
    analyses: SerializedTemplateAnalysis<keyof TemplateTypes>[];
}
export declare class MetaTemplateAnalysis implements StyleAnalysis {
    protected analyses: TemplateAnalysis<keyof TemplateTypes>[];
    protected stylesFound: Map<BlockObject, TemplateAnalysis<keyof TemplateTypes>[]>;
    protected dynamicStyles: Map<BlockObject, TemplateAnalysis<keyof TemplateTypes>[]>;
    constructor();
    optimizationOptions(): TemplateIntegrationOptions;
    addAllAnalyses(analyses: TemplateAnalysis<keyof TemplateTypes>[]): void;
    addAnalysis(analysis: TemplateAnalysis<keyof TemplateTypes>): void;
    analysisCount(): number;
    eachAnalysis(cb: (v: TemplateAnalysis<keyof TemplateTypes>) => any): void;
    styleCount(): number;
    dynamicCount(): number;
    isDynamic(style: BlockObject): boolean;
    blockDependencies(): Set<Block>;
    transitiveBlockDependencies(): Set<Block>;
    serialize(): SerializedMetaTemplateAnalysis;
    forOptimizer(opts: OptionsReader): Array<OptimizedTemplateAnalysis<keyof TemplateTypes>>;
    private addAnalysisToStyleMap(map, style, analysis);
}
