import { BlockObject } from '../Block';
import { Maybe } from "@opticss/util";
import { BooleanExpression, RewriteMapping as OptimizedMapping } from "@opticss/template-api";
import { ClassRewrite, IndexedClassRewrite } from './ClassRewrite';
export declare class IndexedClassMapping implements IndexedClassRewrite<BlockObject> {
    inputs: BlockObject[];
    staticClasses: string[];
    private map;
    private _inputMap;
    constructor(inputs: BlockObject[], staticClasses: string[], map: {
        [k: string]: BooleanExpression<number> | undefined;
    });
    dynamicClass(name: string): BooleanExpression<number> | undefined;
    readonly dynamicClasses: string[];
    indexOf(input: BlockObject): Maybe<number>;
    static fromOptimizer(classRewrite: OptimizedMapping, classMap: Map<string, BlockObject>): IndexedClassMapping;
}
export declare class RewriteMapping implements ClassRewrite<BlockObject> {
    /**
     * output attributes that are always on the element independent of any dynamic changes.
     */
    staticClasses: string[];
    /**
     * The numbers in the boolean expressions represents indexes into the inputAttributes array.
     */
    private _dynamicClasses;
    constructor(staticClasses?: string[], dynamicClasses?: Map<string, BooleanExpression<BlockObject>>);
    readonly dynamicClasses: Array<string>;
    dynamicClass(name: string): BooleanExpression<BlockObject>;
    static fromOptimizer(classRewrite: OptimizedMapping, classMap: Map<string, BlockObject>): RewriteMapping;
}
