import { TemplateAnalysis } from '../TemplateAnalysis';
import { Block, BlockObject } from '../Block';
import { OptionsReader } from '../OptionsReader';
import { RewriteMapping } from './RewriteMapping';
import { ElementAnalysis } from '../TemplateAnalysis/ElementAnalysis';
import { TemplateTypes, StyleMapping as OptimizedMapping } from "@opticss/template-api";
import { IndexedClassRewrite } from "./ClassRewrite";
export declare class StyleMapping {
    /** The analyses that were used to create this mapping. */
    analyses: Array<TemplateAnalysis<keyof TemplateTypes>> | undefined;
    /** The blocks that were used to create this mapping. */
    blocks: Set<Block>;
    private options;
    private optimizedMap;
    constructor(optimizedMap: OptimizedMapping, blocks: Iterable<Block>, options: OptionsReader, analyses?: Array<TemplateAnalysis<keyof TemplateTypes>>);
    simpleRewriteMapping<B, S, T>(element: ElementAnalysis<B, S, T>): IndexedClassRewrite<BlockObject>;
    rewriteMapping<B, S, T>(element: ElementAnalysis<B, S, T>): RewriteMapping;
}
