import { OutputMode } from "./OutputMode";
/**
 * Options used by css-blocks for compilation and analysis.
 */
export interface CssBlockOptions {
    outputMode: OutputMode;
    interoperableCSS: boolean;
    rootDir: string;
    /**
     * Limits block parsing and compilation to this number at any one time.
     * Defaults to: 4
     */
    maxConcurrentCompiles: number;
}
/**
 * Valid user-provided options for the CSS Blocks plugin.
 */
export declare type PluginOptions = Partial<Readonly<CssBlockOptions>>;
export declare type CssBlockOptionsReadonly = Readonly<CssBlockOptions>;
