/**
 * This queue ensures a max concurrency and that, on error, all concurrent
 * work is completed before the error is propagated. New work can be added as
 * needed.
 */
export declare class PromiseQueue<WorkItem, Result> {
    private queue;
    private queueId;
    private jobId;
    private draining;
    private promiseProcessor;
    constructor(concurrency: number, processor: (item: WorkItem) => Promise<Result>);
    private processWork(work, callback);
    readonly activeJobCount: number;
    readonly concurrency: number;
    debug(message: string): void;
    drain(): Promise<void>;
    restart(): void;
    enqueue(item: WorkItem): Promise<Result>;
}
