import BEMProcessor from "./util/BEMProcessor";
export declare class BEMOutputMode extends BEMProcessor {
    "replaces block with the blockname from the file"(): any;
    "handles pseudoclasses on the .root"(): any;
    "handles states"(): any;
    "handles states as scopes"(): any;
    "handles comma-delimited states"(): any;
    "supports arbitrary whitespace in combinators"(): any;
    "a state can be combined with itself"(): any;
    "checkbox with sibling label"(): any;
    "handles exclusive states"(): any;
    "handles exclusive states with single quotes"(): any;
    "handles exclusive states with double quotes"(): any;
    "handles comma-delimited exclusive states"(): any;
    "a exclusive state can be combined with itself"(): any;
    "handles classes"(): any;
    "handles classes with states"(): any;
    "handles classes with class states"(): any;
    "handles root states with class states"(): any;
}
export declare class StraightJacket extends BEMProcessor {
    "catches invalid states"(): any;
    "catches states with colon instead of bar"(): any;
    "cannot combine two different states"(): any;
    "cannot combine two different exclusive states"(): any;
    "disallows combining classes"(): any;
    "disallows sibling combinators with root states"(): any;
    "disallows sibling combinators with root states after adjacent root"(): any;
    "disallows adjacent sibling combinators with root states"(): any;
    "disallows combining classes without a combinator"(): any;
    "allows combining states without a combinator"(): any;
    "allows combining class states without a combinator"(): any;
    "disallows pseudos not attached to a block object."(): any;
    "disallows element names attached to states."(): any;
    "disallows stand-alone attribute selectors except for states."(): any;
    "disallows attribute selectors except for states."(): any;
    "disallows a state before a class for the same element."(): any;
    "disallows combining blocks and classes without a combinator"(): any;
    "disallows combining states and block without a combinator"(): any;
    "disallows !important"(): any;
}
export declare class BlockReferences extends BEMProcessor {
    "can import another block"(): any;
    "if blocks specify name independently of filename, imported name is still used"(): any;
    "block names in double quotes fail parse with helpful error"(): any;
    "block names in single quotes fail parse with helpful error"(): any;
    "block names in double quotes in @block-reference fail parse with helpful error"(): any;
    "block names in single quotes in @block-reference fail parse with helpful error"(): any;
    "block-name property only works in the root ruleset"(): any;
    "doesn't allow a block ref name to collide with a class name"(): void;
    "cannot combine .root with a class as a descendant"(): void;
    "doesn't allow poorly formed names in block-name property"(): any;
    "doesn't allow poorly formed names in import"(): any;
    "requires from statement in @block-reference"(): any;
    "block-name is removed from output"(): any;
    "disallows the :not() pseudoclass."(): any;
    "disallows the :matches() pseudoclass."(): any;
    "@keyframes is left alone"(): any;
    "@media is handled"(): any;
}
