import { ImportedFile, Importer, PathBasedImporter } from "../../src/importing";
import { OptionsReader } from "../../src/OptionsReader";
import { Syntax } from "../../src/preprocessing";
export interface SourceRegistry {
    [sourcePath: string]: {
        contents: string;
        syntax: Syntax;
    };
}
export interface ImportedFiles {
    [sourcePath: string]: boolean;
}
export declare class MockImporter extends PathBasedImporter {
    registry: MockImportRegistry;
    constructor(registry: MockImportRegistry);
    identifier(fromFile: string | null, importPath: string, _options: OptionsReader): string;
    import(resolvedPath: string, options: OptionsReader): Promise<ImportedFile>;
}
export declare class MockImportRegistry {
    sources: SourceRegistry;
    imported: ImportedFiles;
    registerSource(sourcePath: string, contents: string, syntax?: Syntax): void;
    markImported(sourcePath: string): void;
    assertImported(sourcePath: string): void;
    relativize(absolutePath: string): string;
    importer(): Importer;
}
